// **********************************************************************
//
// Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.0
// Generated from file `Location.ice'

#include <Location.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __Hesperia__MLP__LocationDataProvider__getLocationDataInfo_name = "getLocationDataInfo";

static const ::std::string __Hesperia__MLP__Location__getDefaultMsidType_name = "getDefaultMsidType";

static const ::std::string __Hesperia__MLP__Location__getAllowedMsidTypes_name = "getAllowedMsidTypes";

static const ::std::string __Hesperia__MLP__Location__locate_name = "locate";

static const ::std::string __Hesperia__MLP__Location__locateSeq_name = "locateSeq";

static const ::std::string __Hesperia__MLP__Location__locateRange_name = "locateRange";

static const ::std::string __Hesperia__MLP__LocationRequest__locateRequest_name = "locateRequest";

static const ::std::string __Hesperia__MLP__LocationRequest__locateSeqRequest_name = "locateSeqRequest";

static const ::std::string __Hesperia__MLP__LocationRequest__locateRangeRequest_name = "locateRangeRequest";

static const ::std::string __Hesperia__MLP__LocationListener__locateReport_name = "locateReport";

static const ::std::string __Hesperia__MLP__LocationListener__locateSeqReport_name = "locateSeqReport";

static const ::std::string __Hesperia__MLP__LocationListener__locateRangeReport_name = "locateRangeReport";

static const ::std::string __Hesperia__MLP__LocationAdmin__addListener_name = "addListener";

static const ::std::string __Hesperia__MLP__LocationAdmin__removeListener_name = "removeListener";

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::LocationDataProvider* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::LocationDataProvider* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::Location* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::Location* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::LocationRequest* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::LocationRequest* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::LocationListener* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::LocationListener* p) { return p; }

::Ice::Object* IceInternal::upCast(::Hesperia::MLP::LocationAdmin* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::Hesperia::MLP::LocationAdmin* p) { return p; }

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LocationDataProviderPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::LocationDataProvider;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LocationPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::Location;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LocationRequestPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::LocationRequest;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LocationListenerPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::LocationListener;
        v->__copyFrom(proxy);
    }
}

void
Hesperia::MLP::__read(::IceInternal::BasicStream* __is, ::Hesperia::MLP::LocationAdminPrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::Hesperia::MLP::LocationAdmin;
        v->__copyFrom(proxy);
    }
}

bool
Hesperia::MLP::LocationDataInfo::operator==(const LocationDataInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(srsName != __rhs.srsName)
    {
        return false;
    }
    if(distanceUnit != __rhs.distanceUnit)
    {
        return false;
    }
    if(angularUnit != __rhs.angularUnit)
    {
        return false;
    }
    return true;
}

bool
Hesperia::MLP::LocationDataInfo::operator<(const LocationDataInfo& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(srsName < __rhs.srsName)
    {
        return true;
    }
    else if(__rhs.srsName < srsName)
    {
        return false;
    }
    if(distanceUnit < __rhs.distanceUnit)
    {
        return true;
    }
    else if(__rhs.distanceUnit < distanceUnit)
    {
        return false;
    }
    if(angularUnit < __rhs.angularUnit)
    {
        return true;
    }
    else if(__rhs.angularUnit < angularUnit)
    {
        return false;
    }
    return false;
}

void
Hesperia::MLP::LocationDataInfo::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(srsName);
    __os->write(distanceUnit);
    __os->write(angularUnit);
}

void
Hesperia::MLP::LocationDataInfo::__read(::IceInternal::BasicStream* __is)
{
    __is->read(srsName);
    __is->read(distanceUnit);
    __is->read(angularUnit);
}

bool
Hesperia::MLP::Position::operator==(const Position& __rhs) const
{
    if(this == &__rhs)
    {
        return true;
    }
    if(msid != __rhs.msid)
    {
        return false;
    }
    if(time != __rhs.time)
    {
        return false;
    }
    if(theShape != __rhs.theShape)
    {
        return false;
    }
    return true;
}

bool
Hesperia::MLP::Position::operator<(const Position& __rhs) const
{
    if(this == &__rhs)
    {
        return false;
    }
    if(msid < __rhs.msid)
    {
        return true;
    }
    else if(__rhs.msid < msid)
    {
        return false;
    }
    if(time < __rhs.time)
    {
        return true;
    }
    else if(__rhs.time < time)
    {
        return false;
    }
    if(theShape < __rhs.theShape)
    {
        return true;
    }
    else if(__rhs.theShape < theShape)
    {
        return false;
    }
    return false;
}

void
Hesperia::MLP::Position::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(msid);
    __os->write(time);
    __os->write(::Ice::ObjectPtr(::IceInternal::upCast(theShape.get())));
}

void
Hesperia::MLP::Position::__read(::IceInternal::BasicStream* __is)
{
    __is->read(msid);
    __is->read(time);
    __is->read(::Hesperia::MLP::__patch__ShapePtr, &theShape);
}

void
Hesperia::MLP::__writePositionSeq(::IceInternal::BasicStream* __os, const ::Hesperia::MLP::Position* begin, const ::Hesperia::MLP::Position* end)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(end - begin);
    __os->writeSize(size);
    for(int i = 0; i < size; ++i)
    {
        begin[i].__write(__os);
    }
}

void
Hesperia::MLP::__readPositionSeq(::IceInternal::BasicStream* __is, ::Hesperia::MLP::PositionSeq& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 13);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
        v[i].__read(__is);
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

Hesperia::MLP::NotSupported::NotSupported(const ::std::string& __ice_reason) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    reason(__ice_reason)
{
}

Hesperia::MLP::NotSupported::~NotSupported() throw()
{
}

static const char* __Hesperia__MLP__NotSupported_name = "Hesperia::MLP::NotSupported";

::std::string
Hesperia::MLP::NotSupported::ice_name() const
{
    return __Hesperia__MLP__NotSupported_name;
}

::Ice::Exception*
Hesperia::MLP::NotSupported::ice_clone() const
{
    return new NotSupported(*this);
}

void
Hesperia::MLP::NotSupported::ice_throw() const
{
    throw *this;
}

void
Hesperia::MLP::NotSupported::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Hesperia::MLP::NotSupported"), false);
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
Hesperia::MLP::NotSupported::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

void
Hesperia::MLP::NotSupported::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Hesperia::MLP::NotSupported was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::NotSupported::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Hesperia::MLP::NotSupported was not generated with stream support";
    throw ex;
}

struct __F__Hesperia__MLP__NotSupported : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Hesperia::MLP::NotSupported();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Hesperia__MLP__NotSupported__Ptr = new __F__Hesperia__MLP__NotSupported;

const ::IceInternal::UserExceptionFactoryPtr&
Hesperia::MLP::NotSupported::ice_factory()
{
    return __F__Hesperia__MLP__NotSupported__Ptr;
}

class __F__Hesperia__MLP__NotSupported__Init
{
public:

    __F__Hesperia__MLP__NotSupported__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Hesperia::MLP::NotSupported", ::Hesperia::MLP::NotSupported::ice_factory());
    }

    ~__F__Hesperia__MLP__NotSupported__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Hesperia::MLP::NotSupported");
    }
};

static __F__Hesperia__MLP__NotSupported__Init __F__Hesperia__MLP__NotSupported__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__NotSupported__initializer() {} }
#endif

Hesperia::MLP::NotFound::NotFound(const ::std::string& __ice_msid) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    msid(__ice_msid)
{
}

Hesperia::MLP::NotFound::~NotFound() throw()
{
}

static const char* __Hesperia__MLP__NotFound_name = "Hesperia::MLP::NotFound";

::std::string
Hesperia::MLP::NotFound::ice_name() const
{
    return __Hesperia__MLP__NotFound_name;
}

::Ice::Exception*
Hesperia::MLP::NotFound::ice_clone() const
{
    return new NotFound(*this);
}

void
Hesperia::MLP::NotFound::ice_throw() const
{
    throw *this;
}

void
Hesperia::MLP::NotFound::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Hesperia::MLP::NotFound"), false);
    __os->startWriteSlice();
    __os->write(msid);
    __os->endWriteSlice();
}

void
Hesperia::MLP::NotFound::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(msid);
    __is->endReadSlice();
}

void
Hesperia::MLP::NotFound::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Hesperia::MLP::NotFound was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::NotFound::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Hesperia::MLP::NotFound was not generated with stream support";
    throw ex;
}

struct __F__Hesperia__MLP__NotFound : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Hesperia::MLP::NotFound();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Hesperia__MLP__NotFound__Ptr = new __F__Hesperia__MLP__NotFound;

const ::IceInternal::UserExceptionFactoryPtr&
Hesperia::MLP::NotFound::ice_factory()
{
    return __F__Hesperia__MLP__NotFound__Ptr;
}

class __F__Hesperia__MLP__NotFound__Init
{
public:

    __F__Hesperia__MLP__NotFound__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Hesperia::MLP::NotFound", ::Hesperia::MLP::NotFound::ice_factory());
    }

    ~__F__Hesperia__MLP__NotFound__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Hesperia::MLP::NotFound");
    }
};

static __F__Hesperia__MLP__NotFound__Init __F__Hesperia__MLP__NotFound__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__NotFound__initializer() {} }
#endif

Hesperia::MLP::NotFoundMultiple::NotFoundMultiple(const ::Ice::StringSeq& __ice_msids) :
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    UserException(),
#else
    ::Ice::UserException(),
#endif
    msids(__ice_msids)
{
}

Hesperia::MLP::NotFoundMultiple::~NotFoundMultiple() throw()
{
}

static const char* __Hesperia__MLP__NotFoundMultiple_name = "Hesperia::MLP::NotFoundMultiple";

::std::string
Hesperia::MLP::NotFoundMultiple::ice_name() const
{
    return __Hesperia__MLP__NotFoundMultiple_name;
}

::Ice::Exception*
Hesperia::MLP::NotFoundMultiple::ice_clone() const
{
    return new NotFoundMultiple(*this);
}

void
Hesperia::MLP::NotFoundMultiple::ice_throw() const
{
    throw *this;
}

void
Hesperia::MLP::NotFoundMultiple::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::Hesperia::MLP::NotFoundMultiple"), false);
    __os->startWriteSlice();
    if(msids.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&msids[0], &msids[0] + msids.size());
    }
    __os->endWriteSlice();
}

void
Hesperia::MLP::NotFoundMultiple::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->read(myId, false);
    }
    __is->startReadSlice();
    __is->read(msids);
    __is->endReadSlice();
}

void
Hesperia::MLP::NotFoundMultiple::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Hesperia::MLP::NotFoundMultiple was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::NotFoundMultiple::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "exception Hesperia::MLP::NotFoundMultiple was not generated with stream support";
    throw ex;
}

struct __F__Hesperia__MLP__NotFoundMultiple : public ::IceInternal::UserExceptionFactory
{
    virtual void
    createAndThrow()
    {
        throw ::Hesperia::MLP::NotFoundMultiple();
    }
};

static ::IceInternal::UserExceptionFactoryPtr __F__Hesperia__MLP__NotFoundMultiple__Ptr = new __F__Hesperia__MLP__NotFoundMultiple;

const ::IceInternal::UserExceptionFactoryPtr&
Hesperia::MLP::NotFoundMultiple::ice_factory()
{
    return __F__Hesperia__MLP__NotFoundMultiple__Ptr;
}

class __F__Hesperia__MLP__NotFoundMultiple__Init
{
public:

    __F__Hesperia__MLP__NotFoundMultiple__Init()
    {
        ::IceInternal::factoryTable->addExceptionFactory("::Hesperia::MLP::NotFoundMultiple", ::Hesperia::MLP::NotFoundMultiple::ice_factory());
    }

    ~__F__Hesperia__MLP__NotFoundMultiple__Init()
    {
        ::IceInternal::factoryTable->removeExceptionFactory("::Hesperia::MLP::NotFoundMultiple");
    }
};

static __F__Hesperia__MLP__NotFoundMultiple__Init __F__Hesperia__MLP__NotFoundMultiple__i;

#ifdef __APPLE__
extern "C" { void __F__Hesperia__MLP__NotFoundMultiple__initializer() {} }
#endif

::Hesperia::MLP::LocationDataInfo
IceProxy::Hesperia::MLP::LocationDataProvider::getLocationDataInfo(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Hesperia__MLP__LocationDataProvider__getLocationDataInfo_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationDataProvider* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationDataProvider*>(__delBase.get());
            return __del->getLocationDataInfo(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Hesperia::MLP::LocationDataProvider::ice_staticId()
{
    return ::Hesperia::MLP::LocationDataProvider::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::LocationDataProvider::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::LocationDataProvider);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::LocationDataProvider::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::LocationDataProvider);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::LocationDataProvider::__newInstance() const
{
    return new LocationDataProvider;
}

::std::string
IceProxy::Hesperia::MLP::Location::getDefaultMsidType(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Hesperia__MLP__Location__getDefaultMsidType_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::Location* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::Location*>(__delBase.get());
            return __del->getDefaultMsidType(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Ice::StringSeq
IceProxy::Hesperia::MLP::Location::getAllowedMsidTypes(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Hesperia__MLP__Location__getAllowedMsidTypes_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::Location* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::Location*>(__delBase.get());
            return __del->getAllowedMsidTypes(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Hesperia::MLP::Position
IceProxy::Hesperia::MLP::Location::locate(const ::std::string& msid, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Hesperia__MLP__Location__locate_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::Location* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::Location*>(__delBase.get());
            return __del->locate(msid, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Hesperia::MLP::PositionSeq
IceProxy::Hesperia::MLP::Location::locateSeq(const ::Ice::StringSeq& msids, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Hesperia__MLP__Location__locateSeq_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::Location* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::Location*>(__delBase.get());
            return __del->locateSeq(msids, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::Hesperia::MLP::PositionSeq
IceProxy::Hesperia::MLP::Location::locateRange(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __checkTwowayOnly(__Hesperia__MLP__Location__locateRange_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::Location* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::Location*>(__delBase.get());
            return __del->locateRange(firstMsid, lastMsid, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Hesperia::MLP::Location::ice_staticId()
{
    return ::Hesperia::MLP::Location::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::Location::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::Location);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::Location::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::Location);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::Location::__newInstance() const
{
    return new Location;
}

void
IceProxy::Hesperia::MLP::LocationRequest::locateRequest(const ::std::string& msid, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationRequest* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationRequest*>(__delBase.get());
            __del->locateRequest(msid, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Hesperia::MLP::LocationRequest::locateSeqRequest(const ::Ice::StringSeq& msids, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationRequest* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationRequest*>(__delBase.get());
            __del->locateSeqRequest(msids, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Hesperia::MLP::LocationRequest::locateRangeRequest(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationRequest* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationRequest*>(__delBase.get());
            __del->locateRangeRequest(firstMsid, lastMsid, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Hesperia::MLP::LocationRequest::ice_staticId()
{
    return ::Hesperia::MLP::LocationRequest::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::LocationRequest::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::LocationRequest);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::LocationRequest::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::LocationRequest);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::LocationRequest::__newInstance() const
{
    return new LocationRequest;
}

void
IceProxy::Hesperia::MLP::LocationListener::locateReport(const ::Hesperia::MLP::Position& pos, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationListener* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationListener*>(__delBase.get());
            __del->locateReport(pos, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Hesperia::MLP::LocationListener::locateSeqReport(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationListener* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationListener*>(__delBase.get());
            __del->locateSeqReport(pos, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Hesperia::MLP::LocationListener::locateRangeReport(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationListener* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationListener*>(__delBase.get());
            __del->locateRangeReport(pos, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapperRelaxed(__delBase, __ex, 0, __cnt);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Hesperia::MLP::LocationListener::ice_staticId()
{
    return ::Hesperia::MLP::LocationListener::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::LocationListener::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::LocationListener);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::LocationListener::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::LocationListener);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::LocationListener::__newInstance() const
{
    return new LocationListener;
}

void
IceProxy::Hesperia::MLP::LocationAdmin::addListener(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationAdmin* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationAdmin*>(__delBase.get());
            __del->addListener(listener, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::Hesperia::MLP::LocationAdmin::removeListener(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
            __delBase = __getDelegate(false);
            ::IceDelegate::Hesperia::MLP::LocationAdmin* __del = dynamic_cast< ::IceDelegate::Hesperia::MLP::LocationAdmin*>(__delBase.get());
            __del->removeListener(listener, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::Hesperia::MLP::LocationAdmin::ice_staticId()
{
    return ::Hesperia::MLP::LocationAdmin::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::Hesperia::MLP::LocationAdmin::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::Hesperia::MLP::LocationAdmin);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::Hesperia::MLP::LocationAdmin::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::Hesperia::MLP::LocationAdmin);
}

::IceProxy::Ice::Object*
IceProxy::Hesperia::MLP::LocationAdmin::__newInstance() const
{
    return new LocationAdmin;
}

::Hesperia::MLP::LocationDataInfo
IceDelegateM::Hesperia::MLP::LocationDataProvider::getLocationDataInfo(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationDataProvider__getLocationDataInfo_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Hesperia::MLP::LocationDataInfo __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __ret.__read(__is);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateM::Hesperia::MLP::Location::getDefaultMsidType(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__Location__getDefaultMsidType_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::std::string __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Ice::StringSeq
IceDelegateM::Hesperia::MLP::Location::getAllowedMsidTypes(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__Location__getAllowedMsidTypes_name, ::Ice::Nonmutating, __context);
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Ice::StringSeq __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Hesperia::MLP::Position
IceDelegateM::Hesperia::MLP::Location::locate(const ::std::string& msid, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__Location__locate_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(msid);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Hesperia::MLP::NotFound&)
            {
                throw;
            }
            catch(const ::Hesperia::MLP::NotSupported&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Hesperia::MLP::Position __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __ret.__read(__is);
        __is->readPendingObjects();
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Hesperia::MLP::PositionSeq
IceDelegateM::Hesperia::MLP::Location::locateSeq(const ::Ice::StringSeq& msids, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__Location__locateSeq_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(msids.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&msids[0], &msids[0] + msids.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Hesperia::MLP::NotFoundMultiple&)
            {
                throw;
            }
            catch(const ::Hesperia::MLP::NotSupported&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Hesperia::MLP::PositionSeq __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Hesperia::MLP::__readPositionSeq(__is, __ret);
        __is->readPendingObjects();
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::Hesperia::MLP::PositionSeq
IceDelegateM::Hesperia::MLP::Location::locateRange(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__Location__locateRange_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(firstMsid);
        __os->write(lastMsid);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Hesperia::MLP::NotFoundMultiple&)
            {
                throw;
            }
            catch(const ::Hesperia::MLP::NotSupported&)
            {
                throw;
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::Hesperia::MLP::PositionSeq __ret;
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::Hesperia::MLP::__readPositionSeq(__is, __ret);
        __is->readPendingObjects();
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::Hesperia::MLP::LocationRequest::locateRequest(const ::std::string& msid, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationRequest__locateRequest_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(msid);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationRequest::locateSeqRequest(const ::Ice::StringSeq& msids, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationRequest__locateSeqRequest_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(msids.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            __os->write(&msids[0], &msids[0] + msids.size());
        }
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationRequest::locateRangeRequest(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationRequest__locateRangeRequest_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(firstMsid);
        __os->write(lastMsid);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationListener::locateReport(const ::Hesperia::MLP::Position& pos, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationListener__locateReport_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        pos.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationListener::locateSeqReport(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationListener__locateSeqReport_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(pos.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Hesperia::MLP::__writePositionSeq(__os, &pos[0], &pos[0] + pos.size());
        }
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationListener::locateRangeReport(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationListener__locateRangeReport_name, ::Ice::Nonmutating, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        if(pos.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Hesperia::MLP::__writePositionSeq(__os, &pos[0], &pos[0] + pos.size());
        }
        __os->writePendingObjects();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationAdmin::addListener(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationAdmin__addListener_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(listener.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::Hesperia::MLP::LocationAdmin::removeListener(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __Hesperia__MLP__LocationAdmin__removeListener_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(::Ice::ObjectPrx(::IceInternal::upCast(listener.get())));
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::Hesperia::MLP::LocationDataInfo
IceDelegateD::Hesperia::MLP::LocationDataProvider::getLocationDataInfo(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Hesperia::MLP::LocationDataInfo& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationDataProvider* servant = dynamic_cast< ::Hesperia::MLP::LocationDataProvider*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getLocationDataInfo(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Hesperia::MLP::LocationDataInfo& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationDataProvider__getLocationDataInfo_name, ::Ice::Nonmutating, __context);
    ::Hesperia::MLP::LocationDataInfo __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::std::string
IceDelegateD::Hesperia::MLP::Location::getDefaultMsidType(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::Location* servant = dynamic_cast< ::Hesperia::MLP::Location*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getDefaultMsidType(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__Location__getDefaultMsidType_name, ::Ice::Nonmutating, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::StringSeq
IceDelegateD::Hesperia::MLP::Location::getAllowedMsidTypes(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Ice::StringSeq& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::Location* servant = dynamic_cast< ::Hesperia::MLP::Location*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getAllowedMsidTypes(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::Ice::StringSeq& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__Location__getAllowedMsidTypes_name, ::Ice::Nonmutating, __context);
    ::Ice::StringSeq __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Hesperia::MLP::Position
IceDelegateD::Hesperia::MLP::Location::locate(const ::std::string& msid, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Hesperia::MLP::Position& __result, const ::std::string& msid, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_msid(msid)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::Location* servant = dynamic_cast< ::Hesperia::MLP::Location*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->locate(_m_msid, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Hesperia::MLP::Position& _result;
        const ::std::string& _m_msid;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__Location__locate_name, ::Ice::Nonmutating, __context);
    ::Hesperia::MLP::Position __result;
    try
    {
        _DirectI __direct(__result, msid, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Hesperia::MLP::NotFound&)
    {
        throw;
    }
    catch(const ::Hesperia::MLP::NotSupported&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Hesperia::MLP::PositionSeq
IceDelegateD::Hesperia::MLP::Location::locateSeq(const ::Ice::StringSeq& msids, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Hesperia::MLP::PositionSeq& __result, const ::Ice::StringSeq& msids, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_msids(msids)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::Location* servant = dynamic_cast< ::Hesperia::MLP::Location*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->locateSeq(_m_msids, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Hesperia::MLP::PositionSeq& _result;
        const ::Ice::StringSeq& _m_msids;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__Location__locateSeq_name, ::Ice::Nonmutating, __context);
    ::Hesperia::MLP::PositionSeq __result;
    try
    {
        _DirectI __direct(__result, msids, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Hesperia::MLP::NotFoundMultiple&)
    {
        throw;
    }
    catch(const ::Hesperia::MLP::NotSupported&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Hesperia::MLP::PositionSeq
IceDelegateD::Hesperia::MLP::Location::locateRange(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::Hesperia::MLP::PositionSeq& __result, const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_firstMsid(firstMsid),
            _m_lastMsid(lastMsid)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::Location* servant = dynamic_cast< ::Hesperia::MLP::Location*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            try
            {
                _result = servant->locateRange(_m_firstMsid, _m_lastMsid, _current);
                return ::Ice::DispatchOK;
            }
            catch(const ::Ice::UserException& __ex)
            {
                setUserException(__ex);
                return ::Ice::DispatchUserException;
            }
        }
        
    private:
        
        ::Hesperia::MLP::PositionSeq& _result;
        const ::std::string& _m_firstMsid;
        const ::std::string& _m_lastMsid;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__Location__locateRange_name, ::Ice::Nonmutating, __context);
    ::Hesperia::MLP::PositionSeq __result;
    try
    {
        _DirectI __direct(__result, firstMsid, lastMsid, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Hesperia::MLP::NotFoundMultiple&)
    {
        throw;
    }
    catch(const ::Hesperia::MLP::NotSupported&)
    {
        throw;
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::Hesperia::MLP::LocationRequest::locateRequest(const ::std::string& msid, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& msid, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_msid(msid)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationRequest* servant = dynamic_cast< ::Hesperia::MLP::LocationRequest*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->locateRequest(_m_msid, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_msid;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationRequest__locateRequest_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(msid, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationRequest::locateSeqRequest(const ::Ice::StringSeq& msids, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Ice::StringSeq& msids, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_msids(msids)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationRequest* servant = dynamic_cast< ::Hesperia::MLP::LocationRequest*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->locateSeqRequest(_m_msids, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Ice::StringSeq& _m_msids;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationRequest__locateSeqRequest_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(msids, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationRequest::locateRangeRequest(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& firstMsid, const ::std::string& lastMsid, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_firstMsid(firstMsid),
            _m_lastMsid(lastMsid)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationRequest* servant = dynamic_cast< ::Hesperia::MLP::LocationRequest*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->locateRangeRequest(_m_firstMsid, _m_lastMsid, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_firstMsid;
        const ::std::string& _m_lastMsid;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationRequest__locateRangeRequest_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(firstMsid, lastMsid, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationListener::locateReport(const ::Hesperia::MLP::Position& pos, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Hesperia::MLP::Position& pos, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_pos(pos)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationListener* servant = dynamic_cast< ::Hesperia::MLP::LocationListener*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->locateReport(_m_pos, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Hesperia::MLP::Position& _m_pos;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationListener__locateReport_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(pos, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationListener::locateSeqReport(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_pos(pos)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationListener* servant = dynamic_cast< ::Hesperia::MLP::LocationListener*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->locateSeqReport(_m_pos, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Hesperia::MLP::PositionSeq& _m_pos;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationListener__locateSeqReport_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(pos, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationListener::locateRangeReport(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Hesperia::MLP::PositionSeq& pos, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_pos(pos)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationListener* servant = dynamic_cast< ::Hesperia::MLP::LocationListener*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->locateRangeReport(_m_pos, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Hesperia::MLP::PositionSeq& _m_pos;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationListener__locateRangeReport_name, ::Ice::Nonmutating, __context);
    try
    {
        _DirectI __direct(pos, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationAdmin::addListener(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_listener(listener)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationAdmin* servant = dynamic_cast< ::Hesperia::MLP::LocationAdmin*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->addListener(_m_listener, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Hesperia::MLP::LocationListenerPrx& _m_listener;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationAdmin__addListener_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(listener, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::Hesperia::MLP::LocationAdmin::removeListener(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::Hesperia::MLP::LocationListenerPrx& listener, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_listener(listener)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::Hesperia::MLP::LocationAdmin* servant = dynamic_cast< ::Hesperia::MLP::LocationAdmin*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->removeListener(_m_listener, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::Hesperia::MLP::LocationListenerPrx& _m_listener;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __Hesperia__MLP__LocationAdmin__removeListener_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(listener, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::Ice::ObjectPtr
Hesperia::MLP::LocationDataProvider::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Hesperia__MLP__LocationDataProvider_ids[2] =
{
    "::Hesperia::MLP::LocationDataProvider",
    "::Ice::Object"
};

bool
Hesperia::MLP::LocationDataProvider::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__LocationDataProvider_ids, __Hesperia__MLP__LocationDataProvider_ids + 2, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::LocationDataProvider::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__LocationDataProvider_ids[0], &__Hesperia__MLP__LocationDataProvider_ids[2]);
}

const ::std::string&
Hesperia::MLP::LocationDataProvider::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__LocationDataProvider_ids[0];
}

const ::std::string&
Hesperia::MLP::LocationDataProvider::ice_staticId()
{
    return __Hesperia__MLP__LocationDataProvider_ids[0];
}

::Ice::DispatchStatus
Hesperia::MLP::LocationDataProvider::___getLocationDataInfo(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Hesperia::MLP::LocationDataInfo __ret = getLocationDataInfo(__current);
    __ret.__write(__os);
    return ::Ice::DispatchOK;
}

static ::std::string __Hesperia__MLP__LocationDataProvider_all[] =
{
    "getLocationDataInfo",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::Ice::DispatchStatus
Hesperia::MLP::LocationDataProvider::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Hesperia__MLP__LocationDataProvider_all, __Hesperia__MLP__LocationDataProvider_all + 5, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Hesperia__MLP__LocationDataProvider_all)
    {
        case 0:
        {
            return ___getLocationDataInfo(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Hesperia::MLP::LocationDataProvider::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Hesperia::MLP::LocationDataProvider::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Hesperia::MLP::LocationDataProvider::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationDataProvider was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::LocationDataProvider::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationDataProvider was not generated with stream support";
    throw ex;
}

void 
Hesperia::MLP::__patch__LocationDataProviderPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LocationDataProviderPtr* p = static_cast< ::Hesperia::MLP::LocationDataProviderPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LocationDataProviderPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::LocationDataProvider::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::LocationDataProvider& l, const ::Hesperia::MLP::LocationDataProvider& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::LocationDataProvider& l, const ::Hesperia::MLP::LocationDataProvider& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Hesperia::MLP::Location::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Hesperia__MLP__Location_ids[3] =
{
    "::Hesperia::MLP::Location",
    "::Hesperia::MLP::LocationDataProvider",
    "::Ice::Object"
};

bool
Hesperia::MLP::Location::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__Location_ids, __Hesperia__MLP__Location_ids + 3, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::Location::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__Location_ids[0], &__Hesperia__MLP__Location_ids[3]);
}

const ::std::string&
Hesperia::MLP::Location::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__Location_ids[0];
}

const ::std::string&
Hesperia::MLP::Location::ice_staticId()
{
    return __Hesperia__MLP__Location_ids[0];
}

::Ice::DispatchStatus
Hesperia::MLP::Location::___getDefaultMsidType(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getDefaultMsidType(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::Location::___getAllowedMsidTypes(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::Ice::StringSeq __ret = getAllowedMsidTypes(__current);
    if(__ret.size() == 0)
    {
        __os->writeSize(0);
    }
    else
    {
        __os->write(&__ret[0], &__ret[0] + __ret.size());
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::Location::___locate(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string msid;
    __is->read(msid);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Hesperia::MLP::Position __ret = locate(msid, __current);
        __ret.__write(__os);
        __os->writePendingObjects();
    }
    catch(const ::Hesperia::MLP::NotFound& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    catch(const ::Hesperia::MLP::NotSupported& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::Location::___locateSeq(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::StringSeq msids;
    __is->read(msids);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Hesperia::MLP::PositionSeq __ret = locateSeq(msids, __current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Hesperia::MLP::__writePositionSeq(__os, &__ret[0], &__ret[0] + __ret.size());
        }
        __os->writePendingObjects();
    }
    catch(const ::Hesperia::MLP::NotFoundMultiple& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    catch(const ::Hesperia::MLP::NotSupported& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::Location::___locateRange(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string firstMsid;
    ::std::string lastMsid;
    __is->read(firstMsid);
    __is->read(lastMsid);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    try
    {
        ::Hesperia::MLP::PositionSeq __ret = locateRange(firstMsid, lastMsid, __current);
        if(__ret.size() == 0)
        {
            __os->writeSize(0);
        }
        else
        {
            ::Hesperia::MLP::__writePositionSeq(__os, &__ret[0], &__ret[0] + __ret.size());
        }
        __os->writePendingObjects();
    }
    catch(const ::Hesperia::MLP::NotFoundMultiple& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    catch(const ::Hesperia::MLP::NotSupported& __ex)
    {
        __os->write(__ex);
        return ::Ice::DispatchUserException;
    }
    return ::Ice::DispatchOK;
}

static ::std::string __Hesperia__MLP__Location_all[] =
{
    "getAllowedMsidTypes",
    "getDefaultMsidType",
    "getLocationDataInfo",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "locate",
    "locateRange",
    "locateSeq"
};

::Ice::DispatchStatus
Hesperia::MLP::Location::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Hesperia__MLP__Location_all, __Hesperia__MLP__Location_all + 10, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Hesperia__MLP__Location_all)
    {
        case 0:
        {
            return ___getAllowedMsidTypes(in, current);
        }
        case 1:
        {
            return ___getDefaultMsidType(in, current);
        }
        case 2:
        {
            return ___getLocationDataInfo(in, current);
        }
        case 3:
        {
            return ___ice_id(in, current);
        }
        case 4:
        {
            return ___ice_ids(in, current);
        }
        case 5:
        {
            return ___ice_isA(in, current);
        }
        case 6:
        {
            return ___ice_ping(in, current);
        }
        case 7:
        {
            return ___locate(in, current);
        }
        case 8:
        {
            return ___locateRange(in, current);
        }
        case 9:
        {
            return ___locateSeq(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Hesperia::MLP::Location::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Hesperia::MLP::Location::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Hesperia::MLP::Location::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Location was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::Location::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::Location was not generated with stream support";
    throw ex;
}

void 
Hesperia::MLP::__patch__LocationPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LocationPtr* p = static_cast< ::Hesperia::MLP::LocationPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LocationPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::Location::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::Location& l, const ::Hesperia::MLP::Location& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::Location& l, const ::Hesperia::MLP::Location& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Hesperia::MLP::LocationRequest::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Hesperia__MLP__LocationRequest_ids[3] =
{
    "::Hesperia::MLP::LocationDataProvider",
    "::Hesperia::MLP::LocationRequest",
    "::Ice::Object"
};

bool
Hesperia::MLP::LocationRequest::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__LocationRequest_ids, __Hesperia__MLP__LocationRequest_ids + 3, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::LocationRequest::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__LocationRequest_ids[0], &__Hesperia__MLP__LocationRequest_ids[3]);
}

const ::std::string&
Hesperia::MLP::LocationRequest::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__LocationRequest_ids[1];
}

const ::std::string&
Hesperia::MLP::LocationRequest::ice_staticId()
{
    return __Hesperia__MLP__LocationRequest_ids[1];
}

::Ice::DispatchStatus
Hesperia::MLP::LocationRequest::___locateRequest(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string msid;
    __is->read(msid);
    __is->endReadEncaps();
    locateRequest(msid, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::LocationRequest::___locateSeqRequest(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Ice::StringSeq msids;
    __is->read(msids);
    __is->endReadEncaps();
    locateSeqRequest(msids, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::LocationRequest::___locateRangeRequest(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string firstMsid;
    ::std::string lastMsid;
    __is->read(firstMsid);
    __is->read(lastMsid);
    __is->endReadEncaps();
    locateRangeRequest(firstMsid, lastMsid, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __Hesperia__MLP__LocationRequest_all[] =
{
    "getLocationDataInfo",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "locateRangeRequest",
    "locateRequest",
    "locateSeqRequest"
};

::Ice::DispatchStatus
Hesperia::MLP::LocationRequest::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Hesperia__MLP__LocationRequest_all, __Hesperia__MLP__LocationRequest_all + 8, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Hesperia__MLP__LocationRequest_all)
    {
        case 0:
        {
            return ___getLocationDataInfo(in, current);
        }
        case 1:
        {
            return ___ice_id(in, current);
        }
        case 2:
        {
            return ___ice_ids(in, current);
        }
        case 3:
        {
            return ___ice_isA(in, current);
        }
        case 4:
        {
            return ___ice_ping(in, current);
        }
        case 5:
        {
            return ___locateRangeRequest(in, current);
        }
        case 6:
        {
            return ___locateRequest(in, current);
        }
        case 7:
        {
            return ___locateSeqRequest(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Hesperia::MLP::LocationRequest::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Hesperia::MLP::LocationRequest::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Hesperia::MLP::LocationRequest::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationRequest was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::LocationRequest::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationRequest was not generated with stream support";
    throw ex;
}

void 
Hesperia::MLP::__patch__LocationRequestPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LocationRequestPtr* p = static_cast< ::Hesperia::MLP::LocationRequestPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LocationRequestPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::LocationRequest::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::LocationRequest& l, const ::Hesperia::MLP::LocationRequest& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::LocationRequest& l, const ::Hesperia::MLP::LocationRequest& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Hesperia::MLP::LocationListener::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Hesperia__MLP__LocationListener_ids[2] =
{
    "::Hesperia::MLP::LocationListener",
    "::Ice::Object"
};

bool
Hesperia::MLP::LocationListener::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__LocationListener_ids, __Hesperia__MLP__LocationListener_ids + 2, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::LocationListener::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__LocationListener_ids[0], &__Hesperia__MLP__LocationListener_ids[2]);
}

const ::std::string&
Hesperia::MLP::LocationListener::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__LocationListener_ids[0];
}

const ::std::string&
Hesperia::MLP::LocationListener::ice_staticId()
{
    return __Hesperia__MLP__LocationListener_ids[0];
}

::Ice::DispatchStatus
Hesperia::MLP::LocationListener::___locateReport(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Hesperia::MLP::Position pos;
    pos.__read(__is);
    __is->readPendingObjects();
    __is->endReadEncaps();
    locateReport(pos, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::LocationListener::___locateSeqReport(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Hesperia::MLP::PositionSeq pos;
    ::Hesperia::MLP::__readPositionSeq(__is, pos);
    __is->readPendingObjects();
    __is->endReadEncaps();
    locateSeqReport(pos, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::LocationListener::___locateRangeReport(::IceInternal::Incoming& __inS, const ::Ice::Current& __current) const
{
    __checkMode(::Ice::Idempotent, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Hesperia::MLP::PositionSeq pos;
    ::Hesperia::MLP::__readPositionSeq(__is, pos);
    __is->readPendingObjects();
    __is->endReadEncaps();
    locateRangeReport(pos, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __Hesperia__MLP__LocationListener_all[] =
{
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "locateRangeReport",
    "locateReport",
    "locateSeqReport"
};

::Ice::DispatchStatus
Hesperia::MLP::LocationListener::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Hesperia__MLP__LocationListener_all, __Hesperia__MLP__LocationListener_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Hesperia__MLP__LocationListener_all)
    {
        case 0:
        {
            return ___ice_id(in, current);
        }
        case 1:
        {
            return ___ice_ids(in, current);
        }
        case 2:
        {
            return ___ice_isA(in, current);
        }
        case 3:
        {
            return ___ice_ping(in, current);
        }
        case 4:
        {
            return ___locateRangeReport(in, current);
        }
        case 5:
        {
            return ___locateReport(in, current);
        }
        case 6:
        {
            return ___locateSeqReport(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Hesperia::MLP::LocationListener::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Hesperia::MLP::LocationListener::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Hesperia::MLP::LocationListener::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationListener was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::LocationListener::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationListener was not generated with stream support";
    throw ex;
}

void 
Hesperia::MLP::__patch__LocationListenerPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LocationListenerPtr* p = static_cast< ::Hesperia::MLP::LocationListenerPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LocationListenerPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::LocationListener::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::LocationListener& l, const ::Hesperia::MLP::LocationListener& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::LocationListener& l, const ::Hesperia::MLP::LocationListener& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}

::Ice::ObjectPtr
Hesperia::MLP::LocationAdmin::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __Hesperia__MLP__LocationAdmin_ids[3] =
{
    "::Hesperia::MLP::LocationAdmin",
    "::Hesperia::MLP::LocationDataProvider",
    "::Ice::Object"
};

bool
Hesperia::MLP::LocationAdmin::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__Hesperia__MLP__LocationAdmin_ids, __Hesperia__MLP__LocationAdmin_ids + 3, _s);
}

::std::vector< ::std::string>
Hesperia::MLP::LocationAdmin::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__Hesperia__MLP__LocationAdmin_ids[0], &__Hesperia__MLP__LocationAdmin_ids[3]);
}

const ::std::string&
Hesperia::MLP::LocationAdmin::ice_id(const ::Ice::Current&) const
{
    return __Hesperia__MLP__LocationAdmin_ids[0];
}

const ::std::string&
Hesperia::MLP::LocationAdmin::ice_staticId()
{
    return __Hesperia__MLP__LocationAdmin_ids[0];
}

::Ice::DispatchStatus
Hesperia::MLP::LocationAdmin::___addListener(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Hesperia::MLP::LocationListenerPrx listener;
    ::Hesperia::MLP::__read(__is, listener);
    __is->endReadEncaps();
    addListener(listener, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
Hesperia::MLP::LocationAdmin::___removeListener(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::Hesperia::MLP::LocationListenerPrx listener;
    ::Hesperia::MLP::__read(__is, listener);
    __is->endReadEncaps();
    removeListener(listener, __current);
    return ::Ice::DispatchOK;
}

static ::std::string __Hesperia__MLP__LocationAdmin_all[] =
{
    "addListener",
    "getLocationDataInfo",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "removeListener"
};

::Ice::DispatchStatus
Hesperia::MLP::LocationAdmin::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__Hesperia__MLP__LocationAdmin_all, __Hesperia__MLP__LocationAdmin_all + 7, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __Hesperia__MLP__LocationAdmin_all)
    {
        case 0:
        {
            return ___addListener(in, current);
        }
        case 1:
        {
            return ___getLocationDataInfo(in, current);
        }
        case 2:
        {
            return ___ice_id(in, current);
        }
        case 3:
        {
            return ___ice_ids(in, current);
        }
        case 4:
        {
            return ___ice_isA(in, current);
        }
        case 5:
        {
            return ___ice_ping(in, current);
        }
        case 6:
        {
            return ___removeListener(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
Hesperia::MLP::LocationAdmin::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
Hesperia::MLP::LocationAdmin::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
Hesperia::MLP::LocationAdmin::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationAdmin was not generated with stream support";
    throw ex;
}

void
Hesperia::MLP::LocationAdmin::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type Hesperia::MLP::LocationAdmin was not generated with stream support";
    throw ex;
}

void 
Hesperia::MLP::__patch__LocationAdminPtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::Hesperia::MLP::LocationAdminPtr* p = static_cast< ::Hesperia::MLP::LocationAdminPtr*>(__addr);
    assert(p);
    *p = ::Hesperia::MLP::LocationAdminPtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::Hesperia::MLP::LocationAdmin::ice_staticId(), v->ice_id());
    }
}

bool
Hesperia::MLP::operator==(const ::Hesperia::MLP::LocationAdmin& l, const ::Hesperia::MLP::LocationAdmin& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
Hesperia::MLP::operator<(const ::Hesperia::MLP::LocationAdmin& l, const ::Hesperia::MLP::LocationAdmin& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
